/* OSBeeWiFi Firmware
 *
 * Main loop wrapper for Arduino
 * June 2016 @ bee.opensprinkler.com
 *
 * This file is part of the OSBeeWiFi library
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <time.h>
#include <TimeLib.h>
#include <FS.h>
#include <BlynkSimpleEsp8266.h>
#include <Wire.h>
#include <SSD1306.h>
#include "i2crtc.h"
#include "OSBeeWiFi.h"

void do_setup();
void do_loop();

void setup() {
  do_setup();
}

void loop() {
  do_loop();
}
